import 'packets-general.dart' show PREFIX, zeros, POSTFIX, Packet;

const SYNC_PREFIX = '02000007';

Packet createTimeSyncPacket(String controllerId) {
  // The step is the difference between the sum of hour/minute/second and the syncPostfix (given as hex value) in the Wine program
  const step = 15;

  final d = DateTime.now();

  // modulo by 256 to cut off the bits to the left

  final syncPostfix =
      ((d.year + d.month + d.day + d.hour + d.minute + d.second + step) % 256) 
          .toRadixString(16)
          .padLeft(2, '0');

  final syncDate = d.year.toRadixString(16).padLeft(4, '0') +
      d.month.toRadixString(16).padLeft(2, '0') +
      d.day.toRadixString(16).padLeft(2, '0') +
      d.hour.toRadixString(16).padLeft(2, '0') +
      d.minute.toRadixString(16).padLeft(2, '0') +
      d.second.toRadixString(16).padLeft(2, '0');

  final data = PREFIX +
      SYNC_PREFIX +
      syncDate +
      zeros(86 - syncDate.length) +
      controllerId +
      syncPostfix +
      POSTFIX;

  return Packet(data, true);
}
